COMMENT #
===============================================================================
 vesa.inc
===============================================================================
#

tVesainf	STRUC
vesai_id	db	4 dup (?)	; VESA ID "VESA"
vesai_ver	dw	?	; Major , Minor (0102h as 1.2)
vesai_oemname	dd	?	; ptr to OEM name
vesai_capa	dd	?	; Capabilities
vesai_vm	dd	?	; ptr to video modes
vesai_total	dw	?	; VRAM amount (by 64k-bytes)
vesai_oemver	dw	?	; OEM version (VBE 2.0)
vesai_vendor	dd	?	; ptr to vendor name (VBE 2.0)
vesai_product	dd	?	; ptr to product name (VBE 2.0)
vesai_revision	dd	?	; ptr to revision str (VBE 2.0)

;(vesai_reserved	db	222 dup (?) )
;(vesai_oem_scratch	db	256 dup (?) )	; VBE 2.0
tVesainf	ENDS


tVesam		STRUC
vesam_attr	dw	?	; [h 
vesam_attrA	db	?	; EChE`
vesam_attrB	db	?	; EChEa
vesam_gra	dw	?	; EChE\iKBPʁj
vesam_size	dw	?	; EChETCYiKBPʁj
vesam_segA	dw	?	; EChE`ZOg
vesam_segB	dw	?	; EChEaZOg
vesam_cntl	dd	?	; EChEݒ֐ւ̃|C^
vesam_bytes	dw	?	; Ps̃oCg
				;  VESA OEM Mode ł̃T|[g 
				; 
vesam_columns	dw	?	; ̃hbgij
vesam_rows	dw	?	; c̃hbgij
vesam_width	db	?	; LN^P̕ihbgPʁj
vesam_height	db	?	; LN^P̍ihbgPʁj
vesam_planes	db	?	; [v[̐
vesam_bitspixel	db	?	; Phbg\ɕKvȃrbgiFj
vesam_banks	db	?	; oN
vesam_mtype	db	?	; [f^Cv
vesam_banksize	db	?	; oNTCY
vesam_pages	db	?	; C[Wy[W
vesam_reserved	db	?
				;  VBE 1.2 ȏ
vesam_masksizeR	db	?	; }XNTCYiԁj
vesam_fposR	db	?	; rbgʒuiԁj
vesam_masksizeG	db	?	; i΁j
vesam_fposG	db	?	;
vesam_masksizeB	db	?	; ij
vesam_fposB	db	?	;
vesam_masksize_	db	?	; i\j
vesam_fpos_	db	?	;
vesam_dcolor	db	?	; _CNgJ[
				;  VBE 2.0 ȏ
vesam_padd	dd	?	; rfIobt@̕AhX
vesam_startoff	dd	?	
vesam_sizeoff	dd	?
tVesam		ENDS

